/*                                                                            */
/*       xnetdb                                                               */
/*                                                                            */
/*       Copyright (C) 1991 The Ohio State University, All Rights Reserved    */
/*       Copyright (C) 1990 Henry Clark, All Rights Reserved                  */
/*                                                                            */
/*       Licensing details are in the file "License"                          */
/*                                                                            */
/*       xnetdb.c                                                             */
/*                                                                            */
/*       this function contains code to run xnetdb stuff                      */
/*                                                                            */


#include "xnetdb.h"


char xnetdb[] = "xnetdb";
int skt;
int signal_sigalarm_handler();
int signal_sighup_handler();
int  child_pid;
char portnum[6];

main(argc, argv)
     int argc;
     char **argv;
{
  int     myscreen;
  XSizeHints myhint;
  int        done;
  Colormap   mycmap;
  int        result;
  int        total_width, total_height;
  int direction_hint;
  int font_ascent, font_descent;
  XCharStruct overall;
  char  text[10];
  KeySym mykey;
  struct sigvec siginfo;
  struct sockaddr_in local;
  int len=sizeof(local);
  int  clkinit();
  int  i,j,xmin,xmax,ymin,ymax,xavg,yavg,xmidpt,ymidpt;
  int  x,y;
  int xr,yr;
  unsigned int buttons;
  Window rw, cw;
  char path[40];
  int frog;
  char froggie[80];


  siginfo.sv_handler = (void *) clkinit;
  siginfo.sv_onstack = 0;
  siginfo.sv_mask = SIGALRM | SIGHUP;
  sigvec(SIGALRM, &siginfo, (struct sigvec *) 0);

                                        /* default to no monitor and color */

  monitor = 0;
  verbose = 0;
  sprintf(bpath, "%s", BPATH);
  sprintf(cpath, "%s", CPATH);

                                        /* parse command-line args */

  display[0] = '\0';
  for (i=1; i<argc; i++) {
    if (strcmp(argv[i], "-bpath") == 0)
      sprintf(bpath, "%s", argv[i+1]);
    if (strcmp(argv[i], "-cpath") == 0)
      sprintf(cpath, "%s", argv[i+1]);
    if (strcmp(argv[i], "-v") == 0)
      verbose = 1;
    if (strcmp(argv[i], "-monitor") == 0) 
      monitor = 1;
    if (strcmp(argv[i], "-display") == 0) 
      sprintf(display, "%s", argv[i+1]);
  }

                                         /* init xnetdb */

  read_config_file();
  read_location_file();
      
                                         /* now start to set up X environ */

  if (strlen(display) > 0) {
    if((mydisplay = XOpenDisplay(display)) == 0) {
      printf("Cannot open display\n");
      exit(1);
    }
  }
  else {
    if((mydisplay = XOpenDisplay("")) == 0) {
      printf("Cannot open display\n");
      exit(1);
    }
  }
  rootwindow = XDefaultRootWindow(mydisplay);
  if (XDefaultDepth(mydisplay, 0) > 2) {
    color = 1;
    b_w = 0;
  }
  else {
    b_w = 1;
    color = 0;
  }
  myscreen = XDefaultScreen(mydisplay);
#ifdef XDEBUG
  XSynchronize(mydisplay, 1);
#endif XDEBUG
  black = XBlackPixel(mydisplay, myscreen);
  white = XWhitePixel(mydisplay, myscreen);
  myhint.x = 40;
  myhint.y = 40;
  myhint.width = 1000;
  myhint.height = 800;
  myhint.flags = PPosition | PSize;
  if (color)
    mywindow = XCreateSimpleWindow(mydisplay, rootwindow,
                                   myhint.x, myhint.y,
                                   myhint.width, myhint.height,
                                   3, white, black);
  else
    mywindow = XCreateSimpleWindow(mydisplay, rootwindow,
                                   myhint.x, myhint.y,
                                   myhint.width, myhint.height,
                                   3, black, white);
  XSetStandardProperties(mydisplay, mywindow, xnetdb, xnetdb, None,
                         argv, argc, &myhint); 
  XStoreName(mydisplay, mywindow, xnetdb);
  XSetIconName(mydisplay, mywindow, xnetdb);
  mygc = XCreateGC(mydisplay, mywindow, 0, 0);
  XSetForeground(mydisplay, mygc, black);
  XSetBackground(mydisplay, mygc, white);
  XSelectInput(mydisplay, mywindow, 
            Button1MotionMask | Button2MotionMask | Button3MotionMask |
            ButtonPressMask | ButtonReleaseMask | ExposureMask | KeyPressMask |
            KeyReleaseMask );
  XMapRaised(mydisplay, mywindow);

                                          /* Get Colors and Load Font */

  mycmap = XDefaultColormap(mydisplay, myscreen);
  if (color) {
    result = XAllocNamedColor(mydisplay, mycmap, "red", &exact, &red);
    result = XAllocNamedColor(mydisplay, mycmap, "green", &exact, &green);
    result = XAllocNamedColor(mydisplay, mycmap, "blue", &exact, &blue);
    result = XAllocNamedColor(mydisplay, mycmap, "orange", &exact, &brown);
    result = XAllocNamedColor(mydisplay, mycmap, "yellow", &exact, &yellow);
    result = XAllocNamedColor(mydisplay, mycmap, "gray", &exact, &gray);
    result = XAllocNamedColor(mydisplay, mycmap, "steel blue", &exact, &orange);
    result = XAllocNamedColor(mydisplay, mycmap, "purple", &exact, &purple);
    result = XAllocNamedColor(mydisplay, mycmap, "gold", &exact, &pink);
  }
  the_font = XLoadFont(mydisplay, "6x10");
  XSetFont(mydisplay, mygc, the_font);
  font_struct = XLoadQueryFont(mydisplay, "6x10");

                                           /* finish the init process */

  for (i=0; i<numrouters; i++) {
    init_snmp_variables(i);
    init_router_box(i);
  }
  init_circuits();
  for (i=0; i<numrouters; i++)
    read_database(i);

                                         /* init query process if needed */

  if (monitor) {
    if ((skt = socket(AF_INET, SOCK_DGRAM, 0)) <= 0) {
      printf("xnetdb: can't open socket\n");
      exit(1);
    }
    fcntl(skt, F_SETFL, FNDELAY);
    local.sin_family = AF_INET;
    local.sin_addr.s_addr = INADDR_ANY;
    local.sin_port = 0;
    bind(skt, &local, sizeof(local));
    getsockname(skt, &local, &len);
    sprintf(portnum, "%d", local.sin_port);
    init_query();
    sprintf(path, "%s/xnetdbquery", bpath);
    if ((child_pid = fork()) == 0) {
      execl(path, "xnetdbquery", portnum, cpath, 0);
      printf("Holy Cow, Batman, the execl failed!\n");
    }
    siginfo.sv_onstack = 0;
    siginfo.sv_mask = SIGALRM | SIGHUP;
    siginfo.sv_handler = (void *) signal_sigalarm_handler;
    sigvec(SIGALRM, &siginfo, (struct sigvec *) 0);
    siginfo.sv_handler = (void *) signal_sighup_handler;
    sigvec(SIGHUP, &siginfo, (struct sigvec *) 0);
    alarm(15);
  }
  else {
    siginfo.sv_handler = (void *) signal_sighup_handler;
    siginfo.sv_onstack = 0;
    siginfo.sv_mask = SIGHUP;
    sigvec(SIGHUP, &siginfo, (struct sigvec *) 0);
  }


                                           /* init event stuff */

  sprintf(event, "No Problems");
  make_event();

                                           /* main event loop */

  done = 0;
  while (done == 0) {
    XNextEvent(mydisplay, &myevent);
    switch (myevent.type) {
      case Expose: if (myevent.xexpose.count == 0) {
                     display_event = myevent;
                     display_map(); 
                   }
                   break;
      case ButtonPress:switch (myevent.xbutton.button) {
                         case 1: XQueryPointer(mydisplay, mywindow, 
                                          &rw, &cw, &xr, &yr, &x, &y, &buttons);
                                 display_menu(x,y);
                                 break;
                       }
      case KeyPress: i = XLookupString (&myevent, text, 10, &mykey, 0);
                     if (i==1 && (text[0] == 'q' || text[0] == 'Q')) done = 1;
                     break;
      case MappingNotify: XRefreshKeyboardMapping(&myevent);
                          break; 
    }
  }

                                        /* make new location.cf... */

  sprintf(filename, "%s/location.cf", cpath);
  frog = open(filename, O_TRUNC | O_CREAT | O_RDWR, 0644);
  for (i=0; i<numrouters; i++) {
    sprintf(froggie, "%s\t%d\t%d\n", router[i].routername, 
                                     router[i].map.x, router[i].map.y);
    write(frog, froggie, strlen(froggie));
  }
  close(frog);

  XFreeGC(mydisplay, mygc);
  XDestroyWindow(mydisplay, mywindow);
  XCloseDisplay(mydisplay);
  if (monitor) {
    close(skt);
    kill(child_pid, SIGKILL);
  }
  return 0;
}


int display_menu(x,y)

int x,y;

{
  int i;
  int x1, x2, y1, y2;
  int found;

  found = 0; 
  for (i=0; i<numrouters; i++) 
    if ((x > router[i].map.computed.x1) && 
        (x < (router[i].map.computed.x1 + router[i].map.computed.x2)) &&
        (y < router[i].map.computed.y1) &&
        (y > (router[i].map.computed.y1 + router[i].map.computed.y2))) {
      display_router_menu(i);
      found = 1;
    }
  if (!found)
    for (i=0; i<numcircuits; i++) {
      if ((circuit[i].map.x1 - circuit[i].map.x2) < 10) {
        if (circuit[i].map.x1 <  circuit[i].map.x2) {
          x1 = circuit[i].map.x1 - 6;
          x2 = circuit[i].map.x2 + 6;
        }
        else {
          x2 = circuit[i].map.x2 - 6;
          x1 = circuit[i].map.x1 + 6;
        }
      }
      else {
        x1 = circuit[i].map.x1;
        x2 = circuit[i].map.x2;
      }
      if ((circuit[i].map.y1 - circuit[i].map.y2) < 10) {
        if (circuit[i].map.y1 <  circuit[i].map.y2) {
          y1 = circuit[i].map.y1 - 6;
          y2 = circuit[i].map.y2 + 6;
        }
        else {
          y2 = circuit[i].map.y2 - 6;
          y1 = circuit[i].map.y1 + 6;
        }
      }
      else {
        y1 = circuit[i].map.y1;
        y2 = circuit[i].map.y2;
      }
      if ((((x1 <= x) && (x2 >= x)) || ((x1 >= x) && (x2 <= x))) &&
          (((y1 >= y) && (y2 <= y)) || ((y1 <= y) && (y2 >= y)))) {
        display_circuit_menu(i);
        found = 1;
      }
    }
  if (!found)
    display_summary_menu();
}


int traceroute(i)

int i;

{
  Window myinfowindow;
  int    sitedone;
  char   dest_net[16], cow[80], moo[100];
  char   text[10];
  KeySym mykey;
  int    numchar;
  int    offset;
  int    j,k;
  char   cow_net[40], cow_default[40];
  char   result[20], next_hop[20];
  int    found, q;

  numchar = 0;
  sitedone = 0;
  offset = 160;
  myinfowindow = XCreateSimpleWindow(mydisplay, mywindow, 50, 50, 280, 30,     
                                                               1, black, white);
  XMapRaised(mydisplay, myinfowindow);
  XSetForeground(mydisplay, mygc, black);
  XDrawString(mydisplay, myinfowindow, mygc, 10, 15, 
                                                 "Enter destination net: ", 23);
  while (sitedone == 0) {
    XNextEvent(mydisplay, &myevent);
    switch (myevent.type) {
      case ButtonRelease: XDestroyWindow(mydisplay, myinfowindow);
                          sitedone = 1;
                          break;
         case KeyRelease: XLookupString(&myevent, text, 10, &mykey, 0);
                          if ((text[0] == '\n') || (text[0] == '\r')) {
                            dest_net[numchar] = 0x00;
                            XDestroyWindow(mydisplay, myinfowindow);
                            sitedone = 1;
                          }
                          else {
                            dest_net[numchar] = text[0];
                            numchar++;
                            XDrawString(mydisplay, myinfowindow, mygc,
                                                       offset, 15, text, 1);
                            offset += 7;
                          }
                          break;
    }
  }

#ifdef DEBUG
  printf("traceroute: dest_net = %s\n", dest_net);
#endif DEBUG

                                  /* now that we know the source and */
                                  /* destination, go do snmp stuff   */
                                  /* and draw path...                */

  display_map();
  sitedone = 0;
  sprintf(cow_net, "1.3.6.1.2.1.4.21.1.7.%s", dest_net);
  sprintf(cow_default, "1.3.6.1.2.1.4.21.1.7.0.0.0.0");
  while (sitedone == 0) {
    found = 0;
    make_snmp_query(router[i].netaddress, cow_net, router[i].community, 2);
    sscanf(snmp_buffer, "%s %s", result, next_hop);
    if (strcmp(result, "IPAddr") != 0) {
      make_snmp_query(router[i].netaddress, cow_default, router[i].community,2);
      sscanf(snmp_buffer, "%s %s", result, next_hop);
      if (strcmp(result, "IPAddr") != 0) {
        sprintf(event, "no route for %s on router %s!", 
                                                dest_net, router[i].routername);
        make_event();
        show_event();
        return 1;
      }
    }
    for (j=0; j<numrouters; j++)
      for (k=0; k<router[j].numinterfaces; k++)
        if (strcmp(next_hop, router[j].interface[k].ip_address) == 0) {
          if (color)
            XSetForeground(mydisplay, mygc, pink);
          else
            XSetLineAttributes(mydisplay, mygc, 4, 
                                             LineOnOffDash, CapButt, JoinMiter);
          XDrawRectangle(mydisplay, mywindow, mygc,
                        router[j].map.computed.x1, router[j].map.computed.y1,
                        router[j].map.computed.x2, router[j].map.computed.y2);
          for (q=0; q<numcircuits; q++) {
            if (
  (strcmp(router[circuit[q].from_rtr].routername, router[i].routername) == 0) &&
  (strcmp(router[circuit[q].to_rtr].routername, router[j].routername) == 0))
              XDrawLine(mydisplay, mywindow, mygc, 
                      circuit[q].map.x1, circuit[q].map.y1, 
                      circuit[q].map.x2, circuit[q].map.y2);
            if (
  (strcmp(router[circuit[q].to_rtr].routername, router[i].routername) == 0) &&
  (strcmp(router[circuit[q].from_rtr].routername, router[j].routername) == 0))
              XDrawLine(mydisplay, mywindow, mygc, 
                      circuit[q].map.x1, circuit[q].map.y1, 
                      circuit[q].map.x2, circuit[q].map.y2);
          }
          if (strcmp(router[i].netaddress, router[j].netaddress) == 0)
            sitedone = 1;
          i = j; 
#ifdef DEBUG
          printf("next hop = %s\n", router[i].netaddress);
#endif DEBUG
          found = 1;
        }
    if ((strcmp(next_hop, "0.0.0.0") == 0) || (found == 0))
      sitedone = 1;
  }
  sprintf(event, "Press any mouse button...");
  make_event();
  show_event();
  sitedone = 0;
  while (sitedone == 0) {
    XNextEvent(mydisplay, &myevent);
    switch (myevent.type) {
      case ButtonRelease: sitedone = 1;
                          break;
    }
  }
  sprintf(event, "Traceroute done...");
  make_event();
  show_event();
  display_map();
}


int signal_sighup_handler()

{

  int i;

  if (monitor) {
    kill(child_pid, SIGKILL);
    wait(0);
  }
  read_config_file();
  read_location_file();
  for (i=0; i<numrouters; i++)
    init_snmp_variables(i);
  init_circuits();
  for (i=0; i<numrouters; i++)
    read_database(i);
  display_map();
  if (monitor)
    if ((child_pid = fork()) == 0) {
      execl("/usr/local/bin/xnetdbquery", "xnetdbquery", portnum, 0);
      printf("Holy Cow, Batman, the execl failed!\n");
    }
}


int signal_sigalarm_handler()

{
  char buf[BUFSIZ];
  char string1[10], string2[60], string3[10], string4[60], string5[10];
  int i,j;
  int change;

  change = 0;
  while (read(skt, buf, BUFSIZ) > 0) {
    sscanf(buf, "%s %s %s %s %s", string1, string2, string3, string4, string5);
#ifdef DEBUG
    printf("mesg = %s\n", buf);
#endif DEBUG
    if (strcmp(string1, "RTR") == 0) {
      for (i=0; i<numrouters; i++) 
        for (j=0; j<router[i].numinterfaces; j++)
          if (strcmp(string4, router[i].interface[j].ip_address) == 0) {
            if (strcmp(string5, "UP") == 0) {
              if (router[i].interface[j].oper_status != 1) {
                 sprintf(event, "Router %s interface %d came UP!  ",
                                                       router[i].routername, j);
                make_event();
                show_event();
                change = 1;
                if (verbose)
                   printf("Xnetdb: Router %s interface %d came up!\n",
                                                       router[i].routername, j);
              }
              router[i].interface[j].oper_status = 1;
            }
            if (strcmp(string5, "DN") == 0) {
               if (router[i].interface[j].oper_status != 2) {
                 sprintf(event, "Router %s interface %d went DOWN!",
                                                       router[i].routername, j);
                 make_event();
                 show_event();
                 change = 1;
                 if (verbose)
                   printf("Xnetdb: Router %s interface %d went down!\n",
                                                       router[i].routername, j);
               }
               router[i].interface[j].oper_status = 2;
             }
             if (strcmp(string5, "TG") == 0) {
               if (router[i].interface[j].oper_status != 3) {
                 sprintf(event, "Router %s interface %d in TESTING mode!",
                                                       router[i].routername, j);
                 make_event();
                 show_event();
                 change = 1;
                 if (verbose)
                   printf("Xnetdb: Router %s interface %d now testing!\n",
                                                       router[i].routername, j);
               }
               router[i].interface[j].oper_status = 3;
             }
           }
    }
    if (strcmp(string1, "VAR") == 0) {
      if (strcmp(string5, "OK") != 0) {
        sprintf(event, "%s %s in Error!", string2, string4);
        make_event();
        show_event();
        if (verbose)
          printf("Xnetdb: Variable %s %s in error!\n", string2, string4);
      }
    }
    for (i=0; i<BUFSIZ; i++)
      buf[i] = 0x00;
  }

  if (b_w && change)
    display_map();
  else
    redisplay_map();
  XFlush(mydisplay);
  alarm(15);
}


int get_date(date)

char *date;

{
  Window myinfowindow;
  int    sitedone;
  char   text[10];
  int    numchar;
  int    offset;
  KeySym mykey;

  numchar = 0;
  sitedone = 0;
  offset = 160;
  myinfowindow = XCreateSimpleWindow(mydisplay, mywindow, 50, 50, 280, 30,     
                                                               1, black, white);
  XMapRaised(mydisplay, myinfowindow);
  XSetForeground(mydisplay, mygc, black);
  XDrawString(mydisplay, myinfowindow, mygc, 10, 15, 
                                                 "Enter day of interest: ", 23);
  while (sitedone == 0) {
    XNextEvent(mydisplay, &myevent);
    switch (myevent.type) {
      case ButtonRelease: XDestroyWindow(mydisplay, myinfowindow);
                          sitedone = 1;
                          break;
         case KeyRelease: XLookupString(&myevent, text, 10, &mykey, 0);
                          if ((text[0] == '\n') || (text[0] == '\r')) {
                            date[numchar] = 0x00;
                            XDestroyWindow(mydisplay, myinfowindow);
                            sitedone = 1;
                          }
                          else {
                            date[numchar] = text[0];
                            numchar++;
                            XSetForeground(mydisplay, mygc, black);
                            XDrawString(mydisplay, myinfowindow, mygc,
                                                       offset, 15, text, 1);
                            offset += 7;
                          }
                          break;
    }
  }
  return numchar;
}


int clkinit()

{
  longjmp(env, TRUE);
  return 0;
}

